zoukankan      html  css  js  c++  java
  • [leetcode-78-Subsets]

    Given a set of distinct integers, nums, return all possible subsets.
    Note: The solution set must not contain duplicate subsets.
    For example,
    If nums = [1,2,3], a solution is:
    [
    [3],
    [1],
    [2],
    [1,2,3],
    [1,3],
    [2,3],
    [1,2],
    []
    ]

    思路:

    首先排序,然后回溯法。

    void backtracking(vector<vector<int>>& subs,vector<int>& sub,vector<int>& nums,int start)
    {
      subs.push_back(sub);
      for(int i = start;i<nums.size();i++)
      {
        sub.push_back(nums[i]);
        backtracking(subs,sub,nums,i+1);
        sub.pop_back();
      }
    }
    vector<vector<int>> subsets(vector<int>& nums)
    {
      sort(nums.begin(),nums.end());
      vector<vector<int>> subs;
       vector<int>sub;
       backtracking(subs,sub,nums,0);   
      return subs;
    }

     另外,leetcode上大神有更详细多样的方法解析,如下:

    Recursive (Backtracking)

    This is a typical problem that can be tackled by backtracking. Since backtracking has a more-or-less similar template, so I do not give explanations for this method.

    class Solution {
    public:
        vector<vector<int>> subsets(vector<int>& nums) {
            sort(nums.begin(), nums.end());
            vector<vector<int>> subs;
            vector<int> sub;  
            genSubsets(nums, 0, sub, subs);
            return subs; 
        }
        void genSubsets(vector<int>& nums, int start, vector<int>& sub, vector<vector<int>>& subs) {
            subs.push_back(sub);
            for (int i = start; i < nums.size(); i++) {
                sub.push_back(nums[i]);
                genSubsets(nums, i + 1, sub, subs);
                sub.pop_back();
            }
        }
    };
    

    Iterative

    This problem can also be solved iteratively. Take [1, 2, 3] in the problem statement as an example. The process of generating all the subsets is like:

    1. Initially: [[]]
    2. Adding the first number to all the existed subsets: [[], [1]];
    3. Adding the second number to all the existed subsets: [[], [1], [2], [1, 2]];
    4. Adding the third number to all the existed subsets: [[], [1], [2], [1, 2], [3], [1, 3], [2, 3], [1, 2, 3]].

    Have you got the idea :-)

    The code is as follows.

    class Solution {
    public:
        vector<vector<int>> subsets(vector<int>& nums) {
            sort(nums.begin(), nums.end());
            vector<vector<int>> subs(1, vector<int>());
            for (int i = 0; i < nums.size(); i++) {
                int n = subs.size();
                for (int j = 0; j < n; j++) {
                    subs.push_back(subs[j]); 
                    subs.back().push_back(nums[i]);
                }
            }
            return subs;
        }
    }; 
    

    Bit Manipulation

    This is the most clever solution that I have seen. The idea is that to give all the possible subsets, we just need to exhaust all the possible combinations of the numbers. And each number has only two possibilities: either in or not in a subset. And this can be represented using a bit.

    There is also another a way to visualize this idea. That is, if we use the above example, 1 appears once in every two consecutive subsets, 2 appears twice in every four consecutive subsets, and 3 appears four times in every eight subsets, shown in the following (initially the 8 subsets are all empty):

    [], [], [], [], [], [], [], []

    [], [1], [], [1], [], [1], [], [1]

    [], [1], [2], [1, 2], [], [1], [2], [1, 2]

    [], [1], [2], [1, 2], [3], [1, 3], [2, 3], [1, 2, 3]

    The code is as follows.

    class Solution {
    public:
        vector<vector<int>> subsets(vector<int>& nums) {
            sort(nums.begin(), nums.end());
            int num_subset = pow(2, nums.size()); 
            vector<vector<int> > res(num_subset, vector<int>());
            for (int i = 0; i < nums.size(); i++)
                for (int j = 0; j < num_subset; j++)
                    if ((j >> i) & 1)
                        res[j].push_back(nums[i]);
            return res;  
        }
    };
    

    Well, just a final remark. For Python programmers, this may be an easy task in practice since the itertools package has a function combinations for it :-)

    参考:

    https://discuss.leetcode.com/topic/19110/c-recursive-iterative-bit-manipulation-solutions-with-explanations

  • 相关阅读:
    用Python完成一个汇率转换器
    鸿蒙如何用JS开发智能手表App
    鸿蒙如何用JS开发智能手表App
    SAP Spartacus SplitViewComponent Migration 的一个具体例子
    SAP Spartacus B2B 页面 Popover Component 的条件显示逻辑
    SAP Spartacus 升级时关于 schematics 的更新
    SAP Spartacus B2B 页面 Disable 按钮的显示原理
    SAP Spartacus B2B 页面 Disable Confirmation 对话框的显示原理
    通过 Feature Level 动态控制 SAP Spartacus 的页面显示
    SAP Commerce Cloud Build Manifest Components
  • 原文地址:https://www.cnblogs.com/hellowooorld/p/6938565.html
Copyright © 2011-2022 走看看